#ifndef INITIALPARAMS_H
#define INITIALPARAMS_H

#include <defines.h>
#include <string>
#include <fstream>
#include <sstream>
#include <stdexcept>
#include <vector>

using namespace std;

namespace HSEGTilton
{

  class InitialParams 
  {
    public:
    // Constructor and Destructor
      InitialParams();
      virtual ~InitialParams();

    // Member functions
      bool read(const char *param_file);
      bool read_oparam();
      void set_temp_files();
      void print();
      void print_oparam();
      void remove_temp_files();

    // Member variables (public)

    /*-- RHSEG output parameter file (required) --*/
      string  oparam_file;            /*-- USER INPUT FILE NAME --*/

    /*-- Input training field sample data (required) --*/
      string training_samples_file;   /*-- USER INPUT IMAGE FILENAME --*/

    /*-- Output log file (required) --*/
      string  log_file;               /*-- USER INPUT FILENAME --*/
      fstream log_fs;                 /*-- ASSOCIATED FILE STREAM --*/

    /* Default filename prefix */
      string prefix;                  /* -- PROGRAM PARAMETER --*/

    /*-- Temporary files --*/
      string   temp_seg_level_label_file;

    /*-- Exit status from paramGUI --*/
      bool status;                        /*-- PROGRAM PARAMETER --*/

    protected:

    private:

  };

} // HSEGTilton

#endif /* INITIALPARAMS_H */
